/*
*  Name:      date.cc
*  Author:    Rafael Jesus Alcantara Perez
*  Summary:   UESQLC base SQL type date
*  Date:      $Date: 2003-11-27 12:34:16 +0100 (jue, 27 nov 2003) $
*  Revision:  $Revision: 8538 $
*
*  Copyright (C) 2002  Rafael Jesus Alcantara Perez <rafa@dedaloingenieros.com>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
*  MA 02111-1307, USA.
*/

#include <uesqlc/date.hh>


//
//  C O N S T R U C T O R S
//

void uesqlc::TDate::set (const char* pkcVALUE)
{

  using mpcl::text::TString;
  using std::atoi;
  using std::size_t;
  using std::time_t;

// <FIXME comment="must check for invalid dates">
  setNull ( !pkcVALUE || !*pkcVALUE );
  if ( !isNull() )
  {
    int       iDay;
    int       iMonth;
    int       iYear;
    TString   yValue (pkcVALUE);
    size_t    zBegin = 0;
    size_t    zEnd   = 0;

    //
    //  First it cleans the source date, and then obtains the year.
    //
    yValue.suppressFirst ('\'');
    yValue.suppressLast ('\'');
    zEnd  = yValue.find ('-');
    iYear = atoi (yValue.substr (0, zEnd).c_str());

    //
    //  Second it obtains the month and the day
    //
    zBegin = zEnd + 1;
    zEnd   = yValue.find ('-', zBegin);
    iMonth = atoi (yValue.substr (zBegin, zEnd - zBegin).c_str());
    iDay   = atoi (yValue.substr (zEnd + 1).c_str());
    TLocalDate::set (iYear, iMonth, iDay);
  }
// </FIXME>

}  // set()
