/*
*  Name:      test-sqlstate_descriptor.cc
*  Author:    Rafael Jesus Alcantara Perez
*  Summary:   Test for class TSqlstateDescriptor
*  Date:      $Date: 2003-11-27 12:34:16 +0100 (jue, 27 nov 2003) $
*  Revision:  $Revision: 8538 $
*
*  Copyright (C) 1999-2003  Rafael Jesus Alcantara Perez <rafa@dedaloingenieros.com>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
*  MA 02111-1307, USA.
*/

#include <mpcl/test.h>
#include <uesqlc/defs.hh>


///  Main.
int main (void)
{

  TEST_INIT ("tests for class 'TSqlstateDescriptor'");
  TEST_START_WATCH;

  uesqlc::TSqlstateDescriptor   tSqlstateDescriptor;

  //
  //  Tests for class messages.
  //
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("3C000"), "ambiguous cursor name");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("21000"), "cardinality violation");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("08000"), "connection exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("08003"), "connection exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("08006"), "connection exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("08002"), "connection exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("08001"), "connection exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("08004"), "connection exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("08007"), "connection exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22000"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22021"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22008"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22012"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22005"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22022"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22015"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22018"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22007"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22019"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22025"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22023"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22009"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22002"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22003"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22026"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22001"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22011"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22027"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("22024"), "data exception");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("2B000"), "dependent privilege descriptors still exist");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("07000"), "dynamic SQL error");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("07003"), "dynamic SQL error");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("07008"), "dynamic SQL error");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("07009"), "dynamic SQL error");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("07005"), "dynamic SQL error");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("07006"), "dynamic SQL error");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("07001"), "dynamic SQL error");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("07002"), "dynamic SQL error");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("07004"), "dynamic SQL error");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("07007"), "dynamic SQL error");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("0A000"), "feature not supported");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("0A001"), "feature not supported");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("23000"), "integrity constraint violation");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("28000"), "invalid authorization specification");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("3D000"), "invalid catalog name");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("2C000"), "invalid character set name");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("35000"), "invalid condition number");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("2E000"), "invalid connection name");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("34000"), "invalid cursor name");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("24000"), "invalid cursor state");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("3F000"), "invalid schema name");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("33000"), "invalid SQL descriptor name");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("26000"), "invalid SQL statement name");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("25000"), "invalid transaction state");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("2D000"), "invalid transaction termination");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("02000"), "no data");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("HZ000"), "remote database access");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("00000"), "successful completion");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("42000"), "syntax error or access rule violation");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("2A000"), "syntax error or access rule violation in direct statement");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("37000"), "syntax error or access rule violation in dynamic statement");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("40000"), "transaction rollback");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("40002"), "transaction rollback");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("40001"), "transaction rollback");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("40003"), "transaction rollback");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("27000"), "triggered data change violation");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("01000"), "warning");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("01001"), "warning");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("01002"), "warning");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("01008"), "warning");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("01005"), "warning");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("01003"), "warning");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("01007"), "warning");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("01006"), "warning");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("0100A"), "warning");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("01009"), "warning");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("01004"), "warning");
  TEST_STRINGS (tSqlstateDescriptor.getClassValue ("44000"), "with check option violation");

  //
  //  Tests for subclass messages.
  //
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("3C000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("21000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("08000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("08003"), "connection does not exist");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("08006"), "connection failure");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("08002"), "connection name in use");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("08001"), "SQL-client unable to establish SQL-connection");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("08004"), "SQL-server rejected establishment of SQL-connection");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("08007"), "transaction resolution unknown");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22021"), "character not in repertoire");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22008"), "datetime field overflow");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22012"), "division by zero");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22005"), "error in assignment");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22022"), "indicator overflow");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22015"), "interval field overflow");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22018"), "invalid character value for cast");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22007"), "invalid datetime format");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22019"), "invalid escape character");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22025"), "invalid escape sequence");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22023"), "invalid parameter value");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22009"), "invalid time zone displacement value");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22002"), "null value, no indicator parameter");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22003"), "numeric value out of range");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22026"), "string data, length mismatch");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22001"), "string data, right truncation");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22011"), "substring error");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22027"), "trim error");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("22024"), "unterminated C string");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("2B000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("07000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("07003"), "cursor specification cannot be executed");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("07008"), "invalid descriptor count");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("07009"), "invalid descriptor index");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("07005"), "prepared statement not a cursor specification");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("07006"), "restricted data type attribute violation");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("07001"), "using clause does not match dynamic parameter specifications");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("07002"), "using clause does not match target specifications");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("07004"), "using clause required for dynamic parameters");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("07007"), "using clause required for result fields");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("0A000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("0A001"), "multiple environment transactions");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("23000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("28000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("3D000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("2C000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("35000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("2E000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("34000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("24000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("3F000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("33000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("26000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("25000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("2D000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("02000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("HZ000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("00000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("42000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("2A000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("37000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("40000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("40002"), "integrity constraint violation");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("40001"), "serialization failure");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("40003"), "statement completion unknown");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("27000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("01000"), "(no subclass)");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("01001"), "cursor operation conflict");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("01002"), "disconnect error");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("01008"), "implicit zero-bit padding");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("01005"), "insufficient item descriptor areas");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("01003"), "null value eliminated in set function");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("01007"), "privilege not granted");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("01006"), "privilege not revoked");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("0100A"), "query expression too long for information schema");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("01009"), "search condition too long for information schema");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("01004"), "string data, right truncation");
  TEST_STRINGS (tSqlstateDescriptor.getSubclassValue ("44000"), "(no subclass)");
  TEST_STOP_WATCH;
  TEST_DISPLAY_WATCH ("'TSqlstateDescriptor' benchmark");
  TEST_MEMORY_STATUS;
  TEST_RETURN_CODE;

}  // main()
