/*
*  Name:      invariant_verifier.hh
*  Author:    Rafael Jesus Alcantara Perez
*  Summary:   UESQLC invariant verifier for ANSI/ISO SQL 92
*  Date:      $Date: 2003-11-27 12:34:16 +0100 (jue, 27 nov 2003) $
*  Revision:  $Revision: 8538 $
*
*  Copyright (C) 1996-2002  Rafael Jesus Alcantara Perez <rafa@dedaloingenieros.com>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
*  MA 02111-1307, USA.
*/

#ifndef _INVARIANT_VERIFIER__
#define _INVARIANT_VERIFIER__

#include <mpcl/invariant/verifier.hh>
#include "defs.hh"
#include "stack_value.hh"


///  Invariant verifier for UESQLC.
class TInvariantVerifier : public mpcl::invariant::IVerifier<TStackValue*>
{

  public:

    //
    //  C O N S T R U C T O R S
    //

    ///  Builds a new instance.
    TInvariantVerifier (void);
    

  public:

    //
    //  S E L E C T O R S
    //
    
    /**
    *  Verifies that invariant  corresponding to \a liINVARIANT_IDENTIFIER,
    *  is true.
    *  @param liINVARIANT_IDENTIFIER Invariant identifier.
    *  @return True if invariant is verified.
    */
    bool verify (long int liINVARIANT_IDENTIFIER) const;

};  // class TInvariantVerifier


#endif  // not _INVARIANT_VERIFIER__
