/*
*  Name:      TSearchCondition.java
*  Author:    Rafael Jesus Alcantara Perez
*  Summary:   SQL type identifier.
*  Date:      $Date: 2003-11-27 12:34:16 +0100 (jue, 27 nov 2003) $
*  Revision:  $Revision: 8538 $
*
*  Copyright (C) 2002  Rafael Jesus Alcantara Perez <rafa@dedaloingenieros.com>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
*  MA 02111-1307, USA.
*/

///  Package for UESQL.
package org.uesqlc;


///  SQL type for search conditions (used in SELECT, UPDATE, INSERT, etc.).
public class TSearchCondition extends TString
{

  //
  //  C O N S T R U C T O R S
  //

  /**
  *  Builds a new instance.
  *  @post ( isNull() )
  */
  public TSearchCondition()
  {
    super();
  }

  /**
  *  Builds a new instance.
  *  @param ktIDENTIFIER Source identifier.
  *  @post ( isNull() == ktIDENTIFIER.isNull() )
  */
  public TSearchCondition (final TSearchCondition ktIDENTIFIER)
  {
    super (ktIDENTIFIER.toString());
  }


  //
  //  S E L E C T O R S
  //

  public String get()
  {

    String   yResult;

    if ( isNull() )
    {
      yResult = "null";
    }
    else
    {
      yResult = yValue.toString();
    }
    return yResult;

  }  // get()

}  // class TSearchCondition
