#! /usr/bin/scsh \
-ll lambda-unit-modules.scm -dm -o test-000-general -s
!#

(define-structure test-000-general
  (export)
  (open (with-prefix lambda-unit lambda-unit::)
	scsh
	scheme)

  (begin
    (lambda-unit::test-case
      ""
      (begin
        (let ((class_path          ".")         
              (dbms_server_name    "localhost")
              (postgresql_jdbc_jar "pg73b1jdbc3.jar")
              (test_mode           "interactive_mode")
              (dbms_server_name_property "-Dorg.uesqlc.dbms_server_name=")
              (test_mode_property        "-Dorg.uesqlc.test_mode="))
          (if (getenv "CLASSPATH")           (set! class_path          (getenv "CLASSPATH")))
          (if (getenv "DBMS_SERVER_NAME")    (set! dbms_server_name    (getenv "DBMS_SERVER_NAME")))
          (if (getenv "POSTGRESQL_JDBC_JAR") (set! postgresql_jdbc_jar (getenv "POSTGRESQL_JDBC_JAR")))
          (if (getenv "TESTMODE")            (set! test_mode           (getenv "TESTMODE")))
          (set! class_path                (string-append class_path                ":" postgresql_jdbc_jar))
          (set! test_mode_property        (string-append test_mode_property        test_mode))
          (set! dbms_server_name_property (string-append dbms_server_name_property dbms_server_name))
          (zero? (with-cwd "../../../lib"
                           (run (java ,dbms_server_name_property
                                      ,test_mode_property
                                      -classpath ,class_path
                                      test_000_general)))))))))
